class ZBuffer:
    zNear = 0.001
    zFar = 1.0
    maxDepth = 65536
    a = maxDepth * zFar / (zFar - zNear)
    b = maxDepth * zFar * zNear / (zNear - zFar)

    @staticmethod
    def depth2z(depth: float) -> float:
        return ZBuffer.b / (depth - ZBuffer.a)

    @staticmethod
    def z2depth(z: float) -> float:
        return ZBuffer.a + ZBuffer.b / z

    @staticmethod
    def zbuffer2z(zbuffer: float) -> float:
        return 2 * zbuffer - 1

    @staticmethod
    def zbuffer2depth(zbuffer: float) -> float:
        return ZBuffer.z2depth(2 * zbuffer - 1)

    @staticmethod
    def test():
        assert abs(ZBuffer.depth2z(0) - ZBuffer.zNear) < 1e-7
        assert abs(ZBuffer.depth2z(ZBuffer.maxDepth) - ZBuffer.zFar) < 1e-7
        assert round(ZBuffer.z2depth(ZBuffer.zNear)) == 0
        assert round(ZBuffer.z2depth(ZBuffer.zFar)) == ZBuffer.maxDepth

        for i in range(ZBuffer.maxDepth):
            ip = ZBuffer.z2depth(ZBuffer.depth2z(i))
            assert round(ip) == i
