from gui.input import MouseEvent


class PygameMouseEvent(MouseEvent):

    def __init__(self, type: int, button: int, x: int, y: int, time: float):
        self.__type = type
        self.__button = button
        self.__x = x
        self.__y = y
        self.__time = time

    @property
    def type(self) -> int:
        return self.__type

    @property
    def button(self) -> int:
        return self.__button

    @property
    def time(self) -> float:
        return self.__time

    @property
    def x(self) -> float:
        return self.__x

    @property
    def y(self) -> float:
        return self.__y

    def __str__(self):
        return "{} {} ({},{})".format(self.__type, self.__button, self.__x, self.__y)