from abc import abstractmethod
from typing import List

from . import Layer


class CharactersLayer(Layer):

    @abstractmethod
    def setGridSize(self, width: int, height: int):
        raise NotImplementedError()

    @abstractmethod
    def getCharacterCount(self) -> int:
        raise NotImplementedError()

    @abstractmethod
    def setCharacterCount(self, count: int):
        raise NotImplementedError()

    @abstractmethod
    def setCharacterLocation(self, index: int, x: float, y: float) -> float:
        raise NotImplementedError()

    @abstractmethod
    def setCharacterTile(self, index: int, tileX: float, tileY: float):
        raise NotImplementedError()

    @abstractmethod
    def hideCharacter(self, index: int):
        raise NotImplementedError()

    @abstractmethod
    def getPixelCharacterIndices(self, x: int, y: int) -> List[int]:
        raise NotImplementedError()
