from abc import abstractmethod

from . import Layer
from ..text import TextStyle


class TextLayer(Layer):

    @abstractmethod
    def setStyle(self, style: TextStyle):
        raise NotImplementedError()

    @abstractmethod
    def createTextBox(self, x: int=0, y: int=0) -> int:
        raise NotImplementedError()

    @abstractmethod
    def setTextBoxContent(self, textBoxId: int, content: str):
        raise NotImplementedError()

    @abstractmethod
    def setTextBoxLocation(self, textBoxId: int, x: int, y: int):
        raise NotImplementedError()

    @abstractmethod
    def getTextBoxSize(self, textBoxId: int) -> (int, int):
        raise NotImplementedError()

    @abstractmethod
    def deleteTextBox(self, textBoxId: int):
        raise NotImplementedError()

    @abstractmethod
    def deleteTextBoxes(self):
        raise NotImplementedError()
