from abc import ABC, abstractmethod


class GameMode(ABC):

    @abstractmethod
    def init(self):
        raise NotImplementedError()

    @abstractmethod
    def handleInputs(self):
        raise NotImplementedError()

    @abstractmethod
    def updateState(self):
        raise NotImplementedError()

    @abstractmethod
    def render(self, time: float, epochFrame: float):
        raise NotImplementedError()
