from state import Character
from ..IO import IO
from ..ObjectSerializer import ObjectSerializer


class CharacterSerializer(ObjectSerializer):

    def write(self, io: IO, character: Character):
        io.writeString("character")
        io.writeInt32(character.category)
        io.writeInt32(character.x)
        io.writeInt32(character.y)
        io.writeObject(character.moveDirection)
        io.writeInt32(character.shift)

    def read(self, io: IO) -> Character:
        assert io.readString() == "character"
        character = Character()
        character.category = io.readInt32()
        character.x = io.readInt32()
        character.y = io.readInt32()
        character.moveDirection = io.readObject("Direction")
        character.shift = io.readInt32()
        return character
