from state import Direction
from ..IO import IO
from ..ObjectSerializer import ObjectSerializer


class DirectionSerializer(ObjectSerializer):
    code2value = [
        Direction.NONE,
        Direction.NORTH,
        Direction.EAST,
        Direction.SOUTH,
        Direction.WEST
    ]

    value2code = {
        Direction.NONE: 0,
        Direction.NORTH: 1,
        Direction.EAST: 2,
        Direction.SOUTH: 3,
        Direction.WEST: 4
    }

    def write(self, io: IO, direction: Direction):
        io.writeUInt8(self.value2code[direction])

    def read(self, io: IO) -> Direction:
        return self.code2value[io.readUInt8()]
